GWVA_WIND_OBJ_PRG_MENU_ARROWS:	; a0 : ptr fenetre, d0.w objet cliqu
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a1

	cmp.w #1,d0
	bne.s .fleche_droite

	move.w GWVA_MENU_STRUCT_SCROLL_INDEX(a1),d0
	beq .pas_de_changement_menu
	sub.w #1,d0
	bra .changement_menu

.fleche_droite:
	move.w GWVA_MENU_STRUCT_SCROLL_INDEX(a1),d0
	add.w #1,d0

	move.l GWVA_MENU_STRUCT_PTR(a1),a2
	move.w ob_head(a2),d1		; premier fils de l'objet Root
	mulu #L_OBJECT,d1
	cmp.b #G_BOX,ob_type+1(a2,d1.l)
	beq.s .objet_bar
	move.w ob_tail(a2),d1		; autre fils de l'objet Root
	mulu #L_OBJECT,d1
.objet_bar:	lea (a2,d1.l),a3		; objet bar

	move.w ob_head(a3),d1		; -> objet active = pere des G_TITLE
	save.l d0/a0-a1
	move.l a2,a0
	bsr GWVA_FIND_SON_OBJECT_FROM_ORDINAL	; il exite ?
	load.l d0/a0-a1
	tst d7
	beq.s .fils_trouve
	sub.w #1,d0
.fils_trouve:
.changement_menu:
	cmp.w GWVA_MENU_STRUCT_SCROLL_INDEX(a1),d0
	beq.s .pas_de_changement_menu
	move.w d0,GWVA_MENU_STRUCT_SCROLL_INDEX(a1)

	move.w #0,d0
	move.w #4,d1
	move.w #2,d2	; redraw menu
	bsr GWVA_FORM_WIND_OBJ_PRG_REDRAW_PART

.pas_de_changement_menu:
	bra GWVA_MAIN_EVENTS_LOOP

*--------------------------------------------------------------------------------------*

GWVA_WIND_OBJ_PRG_MENU_BAR:	; a0 : fenetre, d0.w : num obj G_TITLE
	save.l d0/a0
	bsr GWVA_WIND_OBJ_PRG_MENU_CLICK
	load.l d0/a0

.wait_event_mouse:
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a1
	move.l GWVA_MENU_STRUCT_PTR(a1),a2

	save.l d0/a0-a2
	objc_offset a2,d0
	load.l d0/a0-a2

	move.w d0,d1
	mulu #L_OBJECT,d1

	movem.w ob_width(a2,d1.l),d2-d3	; w-h de l'objet click
	movem.w int_out+1*2,d0-d1	; x-y de l'objet click
	clr.w d4
	clr.w d5
	clr.w d6
	clr.w d7

	move.w #%000111,a3		; on attend que la souris sorte de l'item du menu, une touche, un clik souris

.surveille_souris:
	ifd OPT_GWVA_WIND_MENU_TIMER
	tst.l ([GWVA_APP_OBJ_PTR],GWVA_APP_OBJ_EVNT_TIMER)
	beq.s .pas_evnt_timer
	tst.l ([GWVA_APP_OBJ_PTR],GWVA_APP_OBJ_COUNT)
	beq.s .pas_evnt_timer
	save.w d0
	move.w a3,d0
	bset #5,d0
	move.w d0,a3
	load.w d0
.pas_evnt_timer:
	endc

.key_press:
	save.l a0-a2		; on attend que la souris sorte de l'item du menu, une touche, un clik souris
	evnt_multi a3,
&	#$102,#$1,#$0,
&	#1,d0,d1,d2,d3,
&	#0,d4,d5,d6,d7,
&	#GWVA_APP_OBJ_MSG_BUF,
&	<([GWVA_APP_OBJ_PTR],GWVA_APP_OBJ_COUNT)>
	load.l a0-a2

	ifd OPT_GWVA_WIND_MENU_TIMER
	btst #5,d0
	beq.s .pas_evenement_timer

	save.l d0-d7/a0-a2
	move.l GWVA_APP_OBJ_PTR,a0

	jsr ([GWVA_APP_OBJ_EVNT_TIMER,a0])
.pas_de_routine_timer:
	load.l d0-d7/a0-a2
	bra .surveille_souris
.pas_evenement_timer:
	endc

	btst #0,d0
	bne .key_press

	movem.w int_out+1*2,d4-d5	; position souris

	move.w d0,d6		; pour le clic souris

; On doit d'abord tester l'arbre des fleches
	save.l d4-d6/a0-a2
	objc_find #GWVA_WIND_OBJ_MENU_TREE_ARROWS,#0,#7,d4,d5
	load.l d4-d6/a0-a2

	tst d0
	bpl .pas_objet_du_menu

; Attention : on a raccourci l'objet menu  la fenetre et si on recherche dans un menu
; qui depasse de la fenetre, on ne trouve aucun objet ....
; On augemente donc la taille du root  la taille du bureau.

	movem.w ob_x(a2),d0-d1
	movem.w GWVA_APP_OBJ_DESKTOP_X,d2-d3
	add.w GWVA_APP_OBJ_DESKTOP_W,d2
	add.w GWVA_APP_OBJ_DESKTOP_H,d3
	sub.w d0,d2
	sub.w d1,d3
	movem.w ob_width(a2),d0-d1
	movem.w d2-d3,ob_width(a2)

	save.l d0-d1/d4-d6/a0-a2
	objc_find a2,#0,#7,d4,d5
	move.w d0,d2
	load.l d0-d1/d4-d6/a0-a2

	movem.w d0-d1,ob_width(a2)

	move.w d2,d0
	bmi .pas_objet_du_menu		; on est donc en dehors de la fenetre (gauche-haut)

	move.w d0,d1
	mulu #L_OBJECT,d1
	cmp.b #G_TITLE,ob_type+1(a2,d1.l)
	bne .pas_objet_titre

	cmp.w GWVA_WIND_OBJ_MENU_ITEM,d0
	beq .wait_event_mouse		; on est revenu sur le menu selectionn

	btst #DISABLED,ob_state+1(a2,d1.l)
	bne .wait_event_mouse

	save.l d0/a0
	bsr GWVA_WIND_OBJ_PRG_MENU_OFF
	load.l d0/a0

	bra GWVA_WIND_OBJ_PRG_MENU_BAR

.pas_objet_titre:
	cmp.w GWVA_WIND_OBJ_MENU_SUBITEM,d0	; BUG des objets outlined
	bne .on_change_de_sous_item	; est-t-on toujours dans le meme subitem ?

	btst #1,d6
	beq .wait_event_mouse

	lea GWVA_APP_OBJ_MSG_BUF,a3
	move.w #MN_SELECTED,(a3)+
	move.w global+_AESapid,(a3)+
	move.w #0,(a3)+
	move.w GWVA_WIND_OBJ_MENU_ITEM,(a3)+
	move.w GWVA_WIND_OBJ_MENU_SUBITEM,(a3)+
	move.l a2,(a3)+
	move.w GWVA_WIND_OBJ_MENU_DROPDOWN_LIST,(a3)+	; pour faire croire a l'utilisateur un message normal

	save.l a0-a2
	bsr GWVA_WIND_OBJ_PRG_MENU_OFF
	load.l a0-a2

	save.l a0
	move.w GWVA_APP_OBJ_MSG_BUF+4*2,d0	; Menu Idx
	move.l a2,d1			; Tree ad.
	move.l a1,a0
	bsr GWVA_EXEC_MENU_ROUTINE_FROM_MENU_AD_AND_IDX
	load.l a0

	bra GWVA_MAIN_EVENTS_LOOP

.on_change_de_sous_item:
	save.l d0-d1/d4-d6/a0-a2
	bsr GWVA_WIND_OBJ_PRG_MENU_SUBITEM_OFF

	movem.l (sp),d0-d1/d4-d6/a0-a2

	move.l a2,a0
	move.w GWVA_WIND_OBJ_MENU_DROPDOWN_LIST,d1
	bsr GWVA_FIND_ORDINAL_SON_OBJECT	; l'objet sous la souris est-il de la liste
	load.l d0-d1/d4-d6/a0-a2
	tst.w d7
	bmi .pas_objet_liste

	move.w ob_state(a2,d1.l),d2	; tat du sous-item
	btst #3,d2
	bne.s .objet_disable

	move.w d0,GWVA_WIND_OBJ_MENU_SUBITEM
	move.w d2,GWVA_WIND_OBJ_MENU_SUBITEM_STATE
	bset #0,d2			; selection puis affichage

	save.l d0-d2/a0-a2
	v_hide_c

	movem.l (sp),d0-d2/a0-a2

	objc_change a2,d0,GWVA_APP_OBJ_DESKTOP_X,GWVA_APP_OBJ_DESKTOP_X+2,GWVA_APP_OBJ_DESKTOP_X+4,GWVA_APP_OBJ_DESKTOP_X+6,d2,#1

	v_show_c #1
	load.l d0-d2/a0-a2
.objet_disable:
	bra .wait_event_mouse

.pas_objet_liste:

	save.l d6/a0-a2
	wind_find d4,d5
	load.l d6/a0-a2

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0
	bne.s .souris_hors_fenetre

	; on est encore dans la fenetre

	btst #1,d6
	bne.s .clic_en_dehors_menu

	movem.w GWVA_WIND_OBJ_MENU_PTSIN_PARAM,d4-d7	; x1,y1,x2,y2 de la liste
	add.w #1,d6
	add.w #1,d7
	sub.w d4,d6
	sub.w d5,d7		; rentree de zone = liste

	movem.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d0-d1
	movem.w GWVA_WIND_OBJ_INTERNAL_W(a0),d2-d3	; sortie de zone = la fenetre

	move.w #%001111,a3		; on attend que la souris sorte ou rentre, une touche, un clik souris

	bra .surveille_souris
.souris_hors_fenetre:
.fin_menu:
.clic_en_dehors_menu:
.pas_objet_du_menu:
	bsr GWVA_WIND_OBJ_PRG_MENU_OFF

	bra GWVA_MAIN_EVENTS_LOOP

	*------------------------*

GWVA_WIND_OBJ_PRG_MENU_OFF:	; a0 :fenetre
	save.l a0
	bsr GWVA_WIND_OBJ_PRG_MENU_DROPDOWN_OFF

	v_hide_c
	load.l a0

	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a1
	move.l GWVA_MENU_STRUCT_PTR(a1),a2

	objc_change a2,GWVA_WIND_OBJ_MENU_ITEM,GWVA_WIND_OBJ_MENU_CLIPPING,GWVA_WIND_OBJ_MENU_CLIPPING+2,GWVA_WIND_OBJ_MENU_CLIPPING+4,GWVA_WIND_OBJ_MENU_CLIPPING+6,GWVA_WIND_OBJ_MENU_ITEM_STATE,#1

	v_show_c #1
	wind_update #END_MCTRL
	wind_update #END_UPDATE
	rts

GWVA_WIND_OBJ_PRG_MENU_SUBITEM_OFF:		; a0 : fenetre
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a1
	move.l GWVA_MENU_STRUCT_PTR(a1),a2

	move.w GWVA_WIND_OBJ_MENU_SUBITEM,d0
	bmi .pas_de_subitem1

	save.l a0-a2
	v_hide_c

	load.l a0-a2

	objc_change a2,GWVA_WIND_OBJ_MENU_SUBITEM,GWVA_APP_OBJ_DESKTOP_X,GWVA_APP_OBJ_DESKTOP_X+2,GWVA_APP_OBJ_DESKTOP_X+4,GWVA_APP_OBJ_DESKTOP_X+6,GWVA_WIND_OBJ_MENU_SUBITEM_STATE,#1

	v_show_c #1

	move.w #-1,GWVA_WIND_OBJ_MENU_SUBITEM
.pas_de_subitem1:
	rts

GWVA_WIND_OBJ_PRG_MENU_CLICK:	; a0 : fenetre, d0.w : num obj G_TITLE
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a1
	move.l GWVA_MENU_STRUCT_PTR(a1),a2

	save.l d0/a0-a2
	objc_offset a2,d0
	load.l d0/a0-a2

	move.w d0,d1
	mulu #L_OBJECT,d1
	
	save.l d0-d1/a0-a2
	movem.w ob_width(a2,d1.l),d2-d3	; w-h de l'objet click
	movem.w int_out+1*2,d0-d1	; x-y de l'objet click
	move.l GWVA_MENU_STRUCT_PTR(a1),a2

	movem.w ob_x(a2),d4-d6		; x-y-w du Root du menu (taille fenetre)
	move.w GWVA_WIND_OBJ_MENU_HEIGHT(a0),d7
	
	lea GWVA_WIND_OBJ_REDRAW_BOX,a2
	movem.w d4-d7,(a2)
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC
	tst d7
	bmi .pas_intersection		; pas d'intersection : l'objet click n'est pas dans la fenetre ???

	lea GWVA_APP_OBJ_DESKTOP_X,a2
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC	; avec le bureau
	tst d7
	bmi .pas_intersection		; pas d'intersection : l'objet click n'est pas dans l'cran ???

	movem.w d0-d3,GWVA_WIND_OBJ_MENU_CLIPPING	; x,y,w,h

	wind_update #BEG_UPDATE
	wind_update #BEG_MCTRL
	v_hide_c

	movem.l (sp),d0-d1/a0-a2

	move.w ob_state(a2,d1.l),d2	; tat du titre
	move.w d0,GWVA_WIND_OBJ_MENU_ITEM
	move.w d2,GWVA_WIND_OBJ_MENU_ITEM_STATE
	bset #0,d2			; selection puis affichage
	objc_change a2,GWVA_WIND_OBJ_MENU_ITEM,GWVA_WIND_OBJ_MENU_CLIPPING,GWVA_WIND_OBJ_MENU_CLIPPING+2,GWVA_WIND_OBJ_MENU_CLIPPING+4,GWVA_WIND_OBJ_MENU_CLIPPING+6,d2,#1

	v_show_c #1
.pas_intersection:
	load.l d0-d1/a0-a2
	
	save.l d0/a0-a2

	move.l a2,a0
	bsr GWVA_FIND_FATHER_OBJECT	; l'objet a forcement un pre
	move.w d0,d2

	movem.l (sp),d0/a0-a2

	move.l a2,a0
	move.w d2,d1
	bsr GWVA_FIND_ORDINAL_SON_OBJECT
	move.w d0,d2

	load.l d0/a0-a2

	move.w ob_head(a2),d3		; premier fils de l'objet Root
	move.w d3,d4
	mulu #L_OBJECT,d4
	cmp.b #G_IBOX,ob_type+1(a2,d4.l)
	beq.s .objet_dropdowns
	move.w ob_tail(a2),d3		; autre fils de l'objet Root
.objet_dropdowns:

	save.l d0/d3/a0-a2
	move.l a2,a0
	move.w d2,d0
	move.w d3,d1
	bsr GWVA_FIND_SON_OBJECT_FROM_ORDINAL
	move.w d0,GWVA_WIND_OBJ_MENU_DROPDOWN_LIST
	load.l d0/d3/a0-a2

*	move.w d3,d0	; -> on affiche tout le menu ou seulement la liste ?
	bsr GWVA_WIND_OBJ_PRG_MENU_DROPDOWN_ON

	rts

GWVA_WIND_OBJ_PRG_MENU_DROPDOWN_ON:		; a0 : fenetre
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a1
	move.l GWVA_MENU_STRUCT_PTR(a1),a2

	save.l d0/a0-a2
	move.l a2,a0
	move.w GWVA_WIND_OBJ_MENU_DROPDOWN_LIST,d0
	bsr GWVA_WIND_OBJ_PRG_MENU_SAVE_SCREEN
	load.l d0/a0-a2
	tst.w d7
	bmi.s .erreur_malloc

; on rend visible la liste selectione
	save.l d0/a0-a2

	move.w GWVA_MENU_STRUCT_INDEX(a1),d0
	move.w GWVA_WIND_OBJ_MENU_DROPDOWN_LIST,d1
	move.w #0,d2
	bsr GWVA_SHOW_HIDE_TREE

	v_hide_c

	load.l d0/a0-a2

	objc_draw <(GWVA_MENU_STRUCT_PTR,[GWVA_WIND_OBJ_MENU_SPEC_PTR,a0])>,
&	GWVA_WIND_OBJ_MENU_DROPDOWN_LIST,#7,GWVA_APP_OBJ_DESKTOP_X,GWVA_APP_OBJ_DESKTOP_X+2,GWVA_APP_OBJ_DESKTOP_X+4,GWVA_APP_OBJ_DESKTOP_X+6
	v_show_c #1

	clr.w d7

.erreur_malloc:
	move.w #-1,GWVA_WIND_OBJ_MENU_SUBITEM	; pas de sub-item selectionn
	rts

GWVA_WIND_OBJ_PRG_MENU_DROPDOWN_OFF:	; a0 : fenetre
	save.l a0
	bsr GWVA_WIND_OBJ_PRG_MENU_SUBITEM_OFF
	load.l a0

	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a1
	move.l GWVA_MENU_STRUCT_PTR(a1),a2

; on rend invisible la liste selectione
	save.l a0-a2
	move.w GWVA_MENU_STRUCT_INDEX(a1),d0
	move.w GWVA_WIND_OBJ_MENU_DROPDOWN_LIST,d1
	move.w #1,d2
	bsr GWVA_SHOW_HIDE_TREE
	load.l a0-a2

	bsr GWVA_WIND_OBJ_PRG_MENU_RESTORE_SCREEN

	rts

	*-----------------------------------*

GWVA_WIND_OBJ_PRG_MENU_SAVE_SCREEN: ; a0.l : ptr root du menu, d0.w : numro de la dropdown list
; on doit sauvegarder l'cran derrire le menu
	save.w d0
	mulu #L_OBJECT,d0
	movem.w ob_width(a2,d0.l),d2-d3	; w-h de l'objet DROPDOWNS
	move.b ob_spec+1(a2,d0.l),d5	; epaisseur signe de la bordure
	neg.b d5
	tst.b d5
	ble.s .epaisseur_negative1
	ext.w d5
	add.w d5,d2			; bordure des deux cots
	add.w d5,d2			; bordure des deux cots
	add.w d5,d3
	add.w d5,d3
.epaisseur_negative1:
	add.w #2*2,d2
	add.w #2*2,d3		; au cas ou il y ait un objet STRING en outlined dans la liste
	move.w d2,d4
	add.w #15,d4
	and.w #$fff0,d4		; largeur multiple de 16 pixels
	ext.l d4
	divu #8,d4			; largeur en octets pour 1 plan
	mulu GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2,d4	; pour x plan
	ext.l d3
	mulu.l d3,d4		; taille de la zone  sauvegarder en octets

	clr.l GWVA_WIND_OBJ_MENU_PTR_MALLOC

	save.l d2-d3/d5/a0
	MXALLOC #RAM_TT_ST,d4
	move.l d0,d1
	load.l d2-d3/d5/a0
	load.w d0
	tst.l d1
	ble .pas_de_memoire_pour_le_menu

	move.l d1,GWVA_WIND_OBJ_MENU_PTR_MALLOC

	lea GWVA_WIND_OBJ_MENU_MFDB,a2
	move.l d1,(a2)+		; pointeur destination
	move.w d2,(a2)+		; largeur image pixel
	move.w d3,(a2)+		; hauteur image pixel
	move.w d2,d4
	add.w #15,d4
	ext.l d4
	divu #16,d4
	move.w d4,(a2)+		; largeur image en mots
	move.w #0,(a2)+		; device dependent
	move.w GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2,(a2)+
	clr.w (a2)+			; reservs
	clr.w (a2)+
	clr.w (a2)+

	clr.l GWVA_APP_MFDB_SRC

	save.l d2-d3/d5/a0
	objc_offset a0,d0
	load.l d2-d3/d5/a0
	movem.w int_out+1*2,d0-d1	; x-y de l'objet DROPDOWNS
	tst.b d5
	ble.s .epaisseur_negative2
	sub.w d5,d0			; bordure des deux cots
	sub.w d5,d1
.epaisseur_negative2:

	sub.w #2,d0
	sub.w #2,d1			; au cas ou il y ait un objet outlined

	save.w d0-d3
	wind_update #BEG_UPDATE
	v_hide_c
	load.w d0-d3

	sub.w #1,d2
	sub.w #1,d3
	move.w d2,d4
	move.w d3,d5
	add.w d0,d2
	add.w d1,d3
	movem.w d0-d3,ptsin		; source

	clr.w ptsin+8+2*0
	clr.w ptsin+8+2*1
	movem.w d4-d5,ptsin+8+2*2

	move.l ptsin,GWVA_WIND_OBJ_MENU_PTSIN_PARAM
	move.l ptsin+4,GWVA_WIND_OBJ_MENU_PTSIN_PARAM+4
	move.l ptsin+8,GWVA_WIND_OBJ_MENU_PTSIN_PARAM+8
	move.l ptsin+12,GWVA_WIND_OBJ_MENU_PTSIN_PARAM+12

	vro_cpyfm #3,#GWVA_APP_MFDB_SRC,#GWVA_WIND_OBJ_MENU_MFDB	; REPLACE mode

	v_show_c #1
	wind_update #END_UPDATE

	clr.w d7
	rts

.pas_de_memoire_pour_le_menu:
	moveq #GWVA_ERROR_GENERIC,d7
	rts

GWVA_WIND_OBJ_PRG_MENU_RESTORE_SCREEN:
	tst.l GWVA_WIND_OBJ_MENU_PTR_MALLOC
	beq .ecran_pas_reserve

	wind_update #BEG_UPDATE
	v_hide_c

	clr.l GWVA_APP_MFDB_DEST
	move.l GWVA_WIND_OBJ_MENU_PTSIN_PARAM,ptsin+8
	move.l GWVA_WIND_OBJ_MENU_PTSIN_PARAM+4,ptsin+12
	move.l GWVA_WIND_OBJ_MENU_PTSIN_PARAM+8,ptsin
	move.l GWVA_WIND_OBJ_MENU_PTSIN_PARAM+12,ptsin+4
	vro_cpyfm #3,#GWVA_WIND_OBJ_MENU_MFDB,#GWVA_APP_MFDB_DEST,	; REPLACE mode

	v_show_c #1
	wind_update #END_UPDATE

	MFREE GWVA_WIND_OBJ_MENU_PTR_MALLOC
.ecran_pas_reserve:
	rts

	*-------------------------------*

GWVA_WIND_OBJ_PRG_MENU_FIX_OBJECT_ARROW:
	rsrc_obfix #GWVA_WIND_OBJ_MENU_TREE_ARROWS,#0
	rsrc_obfix #GWVA_WIND_OBJ_MENU_TREE_ARROWS,#1
	rsrc_obfix #GWVA_WIND_OBJ_MENU_TREE_ARROWS,#2
	rts	
	