GWVA_WTEXT_OBJ_PRG_CALC_PARAM_TEXT:
	movem.w (a6),d0-d1		; x1,y1 clipping

	sub.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d0
	sub.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d1
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	ext.l d0
	ext.l d1
	divs GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d0
	divs GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d1
	muls GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d0
	muls GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d1	; d0-d1 multiple d'un caractre
	add.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d0
	add.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d1
	add.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	add.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1

	movem.w d0-d1,(a6)

	move.w 2(a6),d2			; y1 clipping
	sub.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d2	; position du rectangle de clipping
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d2
	ext.l d2 				; dans la fentre
	divs GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d2
	add.w GWVA_WTEXT_OBJ_AFF_LIGNE(a1),d2	; num de la ligne  afficher

	move.w (a6),d3			; x1 clipping
	sub.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d3	; position du rectangle de clipping
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d3
	ext.l d3				; dans la fentre
	divs GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d3
	add.w GWVA_WTEXT_OBJ_AFF_COLONNE(a1),d3	; num de la colone  afficher

	move.w 4(a6),d5
	sub.w (a6),d5
	add.w #1,d5			; dx
	ext.l d5
	divs GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d5
	moveq #1,d6
	swap d5
	tst d5
	bne.s .pas_nul2
	moveq #0,d6
.pas_nul2:	swap d5
	add.w d6,d5			; nb de colonne  afficher

	move.w 6(a6),d4
	sub.w 2(a6),d4
	add.w #1,d4			; dy
	ext.l d4
	divs GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d4
	moveq #1,d6
	swap d4
	tst d4
	bne.s .pas_nul3
	moveq #0,d6
.pas_nul3:	swap d4
	add.w d6,d4			; nb de ligne  afficher
	rts

;-----------------------------------------------------------------------------
; GWVA_WTEXT_OBJ_PRG_WRITE_TEXT_IN_WINDOW:	Affiche une partie du buffer dans la fentre.
;	Entres:	d0,d1	: (x,y) pour le dbut du raffichage du texte
;		d2,d3	: (l,c) du buffer o commence le raffichage
;		d4,d5	: nbre de (l,c)  afficher
;		d6	: limite texte = cur_buf_lign ou buf_ligne
;		a0	: ptr sur struc. de la fentre
;	Sortie:
;-----------------------------------------------------------------------------
GWVA_WTEXT_OBJ_PRG_WRITE_TEXT_IN_WINDOW:
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.l GWVA_WTEXT_OBJ_MALOC(a1),a6	; ad du texte
	move d2,d7
	mulu GWVA_WTEXT_OBJ_NB_COLONNES(a1),d7
	add.l d7,a6
	add.w d3,a6			; pointe le dbut du texte  afficher

	lea GWVA_WTEXT_OBJ_INTERMEDIAIRE,a5
	move.w d5,d7		; nbre de caractre  afficher
	subq #1,d7			; sur cette ligne
.rcp:	move.b (a6)+,(a5)+
	tst.b -1(a5)
	beq.s .fin_buffer
	dbf d7,.rcp
	clr.b (a5)+

.fin_buffer
	save.l d0-d6/a0/a1
	save.w d0-d1
	vst_color #1		; noir
	load.w d0-d1
	v_gtext d0,d1,#GWVA_WTEXT_OBJ_INTERMEDIAIRE
	load.l d0-d6/a0/a1

	add.w GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d1
	addq #1,d2
	cmp.w d6,d2
	bgt.s .out			; fin buffer ?
	subq #1,d4			; fin fentre ?
	bne.s GWVA_WTEXT_OBJ_PRG_WRITE_TEXT_IN_WINDOW
.out:	rts

		*--------------------------*
GWVA_WIND_OBJ_PRG_ARROWED_WINDOW_TEXT:		; dplacements dans la fentre ligne-colonne/page
	
	btst #GWVA_WIN_BIT_ICON,GWVA_WIND_OBJ_STATUS+1(a0)	; iconifie ?
	beq.s .window_not_inconified
	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a0	; ptr sur la structure de la fenetre iconifie
.window_not_inconified:

	move GWVA_WIND_OBJ_INTERNAL_H(a0),d0
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d0
	move GWVA_WIND_OBJ_INTERNAL_W(a0),d1
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d1

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a1),GWVA_WTEXT_OBJ_AFF_LIGNE(a1)
	move.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a1),GWVA_WTEXT_OBJ_AFF_COLONNE(a1)

	ext.l d0
	divu GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d0	; nb lignes  l'cran
	ext.l d1
	divu GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d1	; nb colonnes  l'cran

	move.w GWVA_APP_OBJ_MSG_BUF+4*2,d2	; action ?
	
	cmp.w #WA_UPPAGE,d2
	bne.s .pas_page_h
	sub.w d0,GWVA_WTEXT_OBJ_AFF_LIGNE(a1)
.pas_page_h:
	cmp.w #WA_DNPAGE,d2
	bne.s .pas_page_b
	add.w d0,GWVA_WTEXT_OBJ_AFF_LIGNE(a1)
.pas_page_b:
	cmp.w #WA_UPLINE,d2
	bne.s .pas_ligne_h
	sub.w #1,GWVA_WTEXT_OBJ_AFF_LIGNE(a1)
.pas_ligne_h:
	cmp.w #WA_DNLINE,d2
	bne.s .pas_ligne_b
	add.w #1,GWVA_WTEXT_OBJ_AFF_LIGNE(a1)
.pas_ligne_b:
	cmp.w #WA_LFPAGE,d2
	bne.s .pas_page_g
	sub.w d1,GWVA_WTEXT_OBJ_AFF_COLONNE(a1)
.pas_page_g:
	cmp.w #WA_RTPAGE,d2
	bne.s .pas_page_d
	add.w d1,GWVA_WTEXT_OBJ_AFF_COLONNE(a1)
.pas_page_d:
	cmp.w #WA_LFLINE,d2
	bne.s .pas_col_g
	sub.w #1,GWVA_WTEXT_OBJ_AFF_COLONNE(a1)
.pas_col_g:
	cmp.w #WA_RTLINE,d2
	bne.s .pas_col_d
	add.w #1,GWVA_WTEXT_OBJ_AFF_COLONNE(a1)
.pas_col_d:

	move GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1),d2
	add.w #1,d2		; numro de ligne
	sub d0,d2
	cmp.w GWVA_WTEXT_OBJ_AFF_LIGNE(a1),d2	; dpassement de la dernire ligne visible
	bge.s .ok2
	move d2,GWVA_WTEXT_OBJ_AFF_LIGNE(a1)
.ok2:
	tst GWVA_WTEXT_OBJ_AFF_LIGNE(a1)
	bpl.s .ok1
	clr GWVA_WTEXT_OBJ_AFF_LIGNE(a1)

.ok1:	move GWVA_WTEXT_OBJ_NB_COLONNES(a1),d2
	sub d1,d2
	cmp.w GWVA_WTEXT_OBJ_AFF_COLONNE(a1),d2
	bge.s .ok4
	move d2,GWVA_WTEXT_OBJ_AFF_COLONNE(a1)
.ok4:
	tst GWVA_WTEXT_OBJ_AFF_COLONNE(a1)
	bpl.s .ok3
	clr GWVA_WTEXT_OBJ_AFF_COLONNE(a1)
.ok3:
	bsr GWVA_WTEXT_OBJ_PRG_CALCULATE_PVSLIDE2
	bsr GWVA_WTEXT_OBJ_PRG_CALCULATE_PHSLIDE2

	bsr GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW

	rts

GWVA_WIND_OBJ_PRG_HSLIDE_WINDOW_TEXT:
	
	btst #GWVA_WIN_BIT_ICON,GWVA_WIND_OBJ_STATUS+1(a0)	; iconifie ?
	beq.s .window_not_inconified
	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a0	; ptr sur la structure de la fenetre iconifie
.window_not_inconified:

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a1),GWVA_WTEXT_OBJ_AFF_COLONNE(a1)

	move GWVA_APP_OBJ_MSG_BUF+4*2,d1		; % du GEM
	move GWVA_WTEXT_OBJ_NB_COLONNES(a1),d2		; largeur buffer
	move GWVA_WIND_OBJ_INTERNAL_W(a0),d3
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d3

	ext.l d3
	divu GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d3		; largeur fentre

	sub d3,d2
	mulu d2,d1
	divu #1000,d1
	move d1,GWVA_WTEXT_OBJ_AFF_COLONNE(a1)

	bsr GWVA_WTEXT_OBJ_PRG_CALCULATE_PHSLIDE2

	bsr GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW
	rts

GWVA_WIND_OBJ_PRG_VSLIDE_WINDOW_TEXT:

	btst #GWVA_WIN_BIT_ICON,GWVA_WIND_OBJ_STATUS+1(a0)	; iconifie ?
	beq.s .window_not_inconified
	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a0	; ptr sur la structure de la fenetre iconifie
.window_not_inconified:

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a1),GWVA_WTEXT_OBJ_AFF_LIGNE(a1)

	move GWVA_APP_OBJ_MSG_BUF+4*2,d1		; % du GEM
	move GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1),d2	; hauteur buffer
	addq.w #1,d2
	move GWVA_WIND_OBJ_INTERNAL_H(a0),d3
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d3

	ext.l d3
	divu GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d3	; hauteur fentre

	sub d3,d2
	mulu d2,d1
	divu #1000,d1
	move d1,GWVA_WTEXT_OBJ_AFF_LIGNE(a1)

	bsr GWVA_WTEXT_OBJ_PRG_CALCULATE_PHSLIDE2

	bsr GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW
	rts

;-----------------------------------------------------------------------------
; GWVA_WTEXT_OBJ_PRG_WRITE_IN_WINDOW: Affiche une chaine de caractre dans une fentre.
;	Entres:	a0	: ptr sur la structure de la fentre
;		a1	: ptr sur le texte (termin par 0)
;	Sortie:
;-----------------------------------------------------------------------------
GWVA_WTEXT_OBJ_PRG_WRITE_IN_WINDOW:
	bsr.s GWVA_WTEXT_OBJ_PRG_WRITE_IN_BUFFER
	bsr GWVA_WTEXT_OBJ_PRG_WRITE_BUFFER_IN_WINDOW
	rts

;-----------------------------------------------------------------------------
; GWVA_WTEXT_OBJ_PRG_WRITE_IN_BUFFER: Ecrit une chaine dans le buffer de la fentre.
;	Entres:	a0	: ptr sur la structure de la fentre
;		a1	: ptr sur le texte (termin par 0)
;	Sortie:
;-----------------------------------------------------------------------------
GWVA_WTEXT_OBJ_PRG_WRITE_IN_BUFFER:
	cmp.w #GWVA_WIND_TYPE_TEXT,GWVA_WIND_OBJ_TYPE(a0)
	bne .pas_une_fenetre_texte

	tst.w GWVA_WIND_OBJ_GEM_HANDLE(a0)
	bmi .fenetre_non_initialisee

	move.l a1,a3
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1

	move.w GWVA_WTEXT_OBJ_BUF_COLONNE(a1),d0	; colonne courante
	ext.l d0
	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a1),d1	; ligne courante
	ext.l d1
	move.l GWVA_WTEXT_OBJ_MALOC(a1),a2	; A2 pointe sur dbut du buffer

	move GWVA_WTEXT_OBJ_NB_COLONNES(a1),d2	; largeur d'une ligne
	ext.l d2
	move GWVA_WTEXT_OBJ_NB_LIGNES(a1),d3	; hauteur fentre
	ext.l d3

	move d1,d4
	mulu d2,d4
	add.l d0,d4
	lea 0(a2,d4.l),a2		; pointeur courant
	
.next_car:	move.b (a3)+,d4		; MODIF LE 06/06/95 par WAX
	tst.b d4			; lf rempli et retourne au dbut
	beq.s .its_0		; rc descend d'une ligne et retourne au dbut
	cmp.b #lf,d4
	beq .its_lf
	cmp.b #rc,d4
	beq .its_rc
	
	move.b d4,(a2)+
	addq.l #1,d0
	cmp.l d0,d2
	bgt.s .no_end_line
.desc1lign:	clr.l d0
	addq.l #1,d1
	cmp.l d1,d3
	bgt.s .no_end_buf
	subq.l #1,d1		; on remet  la dernire ligne
	subq.w #1,GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a1)	; tout le texte remonte d'une ligne
	subq.w #1,GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1)

; debut du scroll d'une ligne du buffer
	move.l GWVA_WTEXT_OBJ_MALOC(a1),a4
	move d2,d7
	mulu d3,d7
	sub.l d2,d7
	beq.s .one_line
.remonte:	move.b (a4,d2.w),(a4)+
	subq.l #1,d7
	bne.s .remonte
.one_line:
	move d2,d7
	subq #1,d7
.put_spaces:move.b #' ',(a4)+
	dbf d7,.put_spaces
; fin du scroll d'une ligne du buffer

	sub.l d2,a2
.no_end_buf:
.no_end_line:
	bra.s .next_car

.its_0:	move.w d0,GWVA_WTEXT_OBJ_BUF_COLONNE(a1)
	move.w d1,GWVA_WTEXT_OBJ_BUF_LIGNE(a1)
	clr.b (a2)
	rts
.its_lf:	move d2,d7			; attention : le line-feed fait tout !
	sub d0,d7
	subq #1,d7
.cp:	move.b #' ',(a2)+
	dbf d7,.cp
	sub.l d2,a2
	clr.l d0
	bra .next_car

.its_rc:	sub.l d0,a2
	add.l d2,a2

	bra.s .desc1lign

.fenetre_non_initialisee:
.pas_une_fenetre_texte:
	move.w #GWVA_ERROR_GENERIC,d7
	rts

;-----------------------------------------------------------------------------
; GWVA_WTEXT_OBJ_PRG_WRITE_BUFFER_IN_WINDOW:	Ecrit le buffer dans la fentre
;	Entres:	a0	: ptr sur la structure de la fentre
;	Sortie:
;-----------------------------------------------------------------------------
GWVA_WTEXT_OBJ_PRG_WRITE_BUFFER_IN_WINDOW:
	cmp.w #GWVA_WIND_TYPE_TEXT,GWVA_WIND_OBJ_TYPE(a0)
	bne .pas_une_fenetre_texte

	tst.w GWVA_WIND_OBJ_GEM_HANDLE(a0)
	bmi .fenetre_non_initialisee

	btst #0,GWVA_WIND_OBJ_FLAGS(a0)	; bit 8 des attributs de la fentre
	beq .colle		; slider vertical ? -> on colle auto.
	
	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_VSLIDE	; pos vslide
	load.l a0
	move.w int_out+2,d0
	save.l d0/a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_VSLSIZE
	load.l d0/a0
	move.w int_out+2,d1
	cmp.w #1000,d0
	beq.s .colle
	cmp.w #1000,d1
	bne.s .pas_colle

.colle:	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a1),GWVA_WTEXT_OBJ_AFF_LIGNE(a1)

.pas_colle:
	bsr GWVA_WTEXT_OBJ_PRG_CALCULATE_PVSLIDE2	; il faut bien rectifier la position

	bsr.s GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW

	bsr GWVA_WIND_OBJ_PRG_CALCULATE_HVSLIDE
	rts

.fenetre_non_initialisee:
.pas_une_fenetre_texte:
	move.w #GWVA_ERROR_GENERIC,d7
	rts

;-----------------------------------------------------------------------------
; GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW:	Scroll le contenu de la fentre.
;	Entres:	a0	: ptr. sur struc. de la fentre
;	Sortie:
;
; routine de scroll
;	Sortie:	d0,d1	: (x,y) pour le dbut du raffichage du texte
;		d2,d3	: (l,c) du buffer o commence le raffichage
;		d4,d5	: nbre de (l,c)  afficher
;-----------------------------------------------------------------------------
GWVA_WTEXT_OBJ_PRG_SCROLL_WINDOW:
	cmp.w #GWVA_WIND_TYPE_TEXT,GWVA_WIND_OBJ_TYPE(a0)
	bne .pas_une_fenetre_texte

	tst.w GWVA_WIND_OBJ_GEM_HANDLE(a0)
	bmi .fenetre_non_initialisee

	btst #1,GWVA_WIND_OBJ_FLAGS+1(a0)	; fentre ouverte ?
	beq .no_scroll_window

	save.l a0
	wind_update #BEG_UPDATE
	vst_alignment #0,#5		; aligne en haut  gauche (texte)
	move.l (sp),a0

	movem.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d0-d3
	add.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	add.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d2
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d3
	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_BOX
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_FIRSTXYWH
	load.l a0

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a1),d6
	sub.w GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1),d6	; nouvelles lignes  afficher ?
	move.w d6,GWVA_WIND_OBJ_NEW_TEXT_VAR
	move.w GWVA_WTEXT_OBJ_BUF_COLONNE(a1),d6
	sub.w GWVA_WTEXT_OBJ_CUR_BUF_COL(a1),d6
	move.w d6,GWVA_WIND_OBJ_NEW_TEXT_VAR+2

.scroll_all:
	tst.l int_out+6		; largeur & hauteur nulle ?
	beq .no_more_rectangle1

	movem.w int_out+2,d0-d3

	lea GWVA_WIND_OBJ_REDRAW_BOX,a2
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC	; calcul intersection
	tst d7
	bmi .pas_intersec1		; pas d'intersection

	lea GWVA_APP_OBJ_DESKTOP_X,a2
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC	; avec le bureau
	tst d7
	bmi .pas_intersec1		; pas d'intersection

	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_INTERSEC

	add.w d0,d2
	subq #1,d2
	add.w d1,d3
	subq #1,d3
	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_CLIP
	save.l a0
	vs_clip #1,d0,d1,d2,d3		; clip on : x1,y1 -> x2,y2
	load.l a0

; Scrolling et raffichage du texte

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_AFF_LIGNE(a1),d6
	sub.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a1),d6	; dplacement vertical ?
	beq.s .pas_scroll_vertical

	save.l d6/a0
	v_hide_c
	load.l d6/a0

	bsr GWVA_WTEXT_OBJ_PRG_SCROLL_VERT

	save.l d7/a0
	v_show_c #1
	load.l d7/a0

	tst d7
	bmi.s .pas_scroll_vertical

	lea GWVA_WIND_OBJ_REDRAW_BLANK,a6
	bsr GWVA_WTEXT_OBJ_PRG_CALC_PARAM_TEXT
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1),d6
	cmp.w d6,d2
	bgt.s .pas_scroll_vertical

	save.l d0-d6/a0
	v_hide_c
	load.l d0-d6/a0
	bsr GWVA_WTEXT_OBJ_PRG_WRITE_TEXT_IN_WINDOW
	save.l a0
	v_show_c #1
	load.l a0

.pas_scroll_vertical:

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_AFF_COLONNE(a1),d6
	sub.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a1),d6	; dplacement vertical ?
	beq.s .pas_scroll_horizontal

	save.l d6/a0
	v_hide_c
	load.l d6/a0

	bsr GWVA_WTEXT_OBJ_PRG_SCROLL_HORI

	save.l d7/a0
	v_show_c #1
	load.l d7/a0

	tst d7
	bmi.s .pas_scroll_horizontal

	lea GWVA_WIND_OBJ_REDRAW_BLANK,a6
	bsr GWVA_WTEXT_OBJ_PRG_CALC_PARAM_TEXT
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1),d6

	cmp.w d6,d2
	bgt.s .pas_scroll_horizontal

	save.l d0-d6/a0
	v_hide_c
	load.l d0-d6/a0
	bsr GWVA_WTEXT_OBJ_PRG_WRITE_TEXT_IN_WINDOW

	save.l a0
	v_show_c #1
	load.l a0

.pas_scroll_horizontal:
	move.w GWVA_WIND_OBJ_NEW_TEXT_VAR,d6
	bne.s .nouvelles_lignes
	move.w GWVA_WIND_OBJ_NEW_TEXT_VAR+2,d6
	beq .pas_nouvelles_lignes
.nouvelles_lignes:

	bsr GWVA_WTEXT_OBJ_PRG_CALC_PARAM_TEXT2
	tst d7
	bmi.s .pas_nouvelles_lignes

	save.l d0-d5/a0
	v_hide_c
	load.l d0-d5/a0

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a1),d6
	bsr GWVA_WTEXT_OBJ_PRG_WRITE_TEXT_IN_WINDOW

	save.l a0
	v_show_c #1
	load.l a0

.pas_nouvelles_lignes:
	save.l a0
	vs_clip #0,#0,#0,#0,#0		; vire le clipping
	load.l a0

.pas_intersec1:
	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_NEXTXYWH	; rectangle suivant
	load.l a0

	bra .scroll_all

.no_more_rectangle1:
	save.l a0
	wind_update #END_UPDATE
	load.l a0

.no_scroll_window:
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a1),GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1)
	move.w GWVA_WTEXT_OBJ_BUF_COLONNE(a1),GWVA_WTEXT_OBJ_CUR_BUF_COL(a1)

	move.w GWVA_WTEXT_OBJ_AFF_LIGNE(a1),d0
	cmp.w GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a1),d0
	bne.s .yes
	tst GWVA_WIND_OBJ_NEW_TEXT_VAR
	beq.s .no1
.yes:	move.w d0,GWVA_WTEXT_OBJ_CUR_AFF_LIGN(a1)
	bsr GWVA_WIND_OBJ_PRG_CALCULATE_PVSLIDE
.no1:
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_AFF_COLONNE(a1),d0
	cmp.w GWVA_WTEXT_OBJ_CUR_AFF_COL(a1),d0
	beq.s .no2
	move.w d0,GWVA_WTEXT_OBJ_CUR_AFF_COL(a1)
	bsr GWVA_WIND_OBJ_PRG_CALCULATE_PHSLIDE
.no2:
	clr d7
	rts

.fenetre_non_initialisee:
.pas_une_fenetre_texte:
	move.w #GWVA_ERROR_GENERIC,d7
	rts

	;--------------------------------------

GWVA_WTEXT_OBJ_PRG_CALC_PARAM_TEXT2
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	moveq #0,d0
	sub.w GWVA_WTEXT_OBJ_AFF_COLONNE(a1),d0
	muls GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d0
	add.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d0	; d0 = x1 bloc de text  afficher
	add.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0

	move.w GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1),d1
	sub.w GWVA_WTEXT_OBJ_AFF_LIGNE(a1),d1
	muls GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d1
	add.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d1	; d1 = y1 bloc de text  afficher
	add.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1

	move.w GWVA_WTEXT_OBJ_NB_COLONNES(a1),d2
	mulu GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d2	; d2 = dx bloc de text  afficher
	*add.w d0,d2
	*sub.w #1,d2

	move.w GWVA_WTEXT_OBJ_BUF_LIGNE(a1),d3
	sub.w GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1),d3
	add.w #1,d3				; au moins une ligne
	muls GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d3	; d3 = dy bloc de text  afficher
	*add.w d1,d3
	*sub.w #1,d3

; ?ERROR? : dans REDRAW_CLIP il y a des x1 y1 x2 y2 et non x1 y1 w1 h1

;	lea GWVA_WIND_OBJ_REDRAW_CLIP,a2
	lea GWVA_WIND_OBJ_REDRAW_INTERSEC,a2
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC	; calcul intersection
	tst d7
	bmi .pas_intersec		; pas d'intersection

	add.w d0,d2
	sub.w #1,d2
	add.w d1,d3
	sub.w #1,d3

	move d0,d6
	move d1,d7

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	sub.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d0
	sub.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d1
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1
	ext.l d0
	ext.l d1
	divs GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d0
	divs GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d1
	muls GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d0
	muls GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d1	; d0-d1 multiple d'un caractre
	add.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d0
	add.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d1
	add.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	add.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1

	move.w d2,d5
	move.w d7,d2
	sub.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d2	; position du rectangle de clipping
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d2
	ext.l d2 				; dans la fentre
	divs GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d2
	add.w GWVA_WTEXT_OBJ_AFF_LIGNE(a1),d2	; num de la ligne  afficher

	move.w d3,d4
	move.w d6,d3
	sub.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d3	; position du rectangle de clipping
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d3
	ext.l d3				; dans la fentre
	divs GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d3
	add.w GWVA_WTEXT_OBJ_AFF_COLONNE(a1),d3	; num de la colone  afficher

	sub.w d6,d5
	add.w #1,d5			; dx
	ext.l d5
	divs GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d5
	moveq #1,d6
	swap d5
	tst d5
	bne.s .pas_nul
	moveq #0,d6
.pas_nul:	swap d5
	add.w d6,d5			; nb de colonne  afficher

	sub.w d7,d4
	add.w #1,d4			; dy
	ext.l d4
	divs GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d4
	moveq #1,d6
	swap d4
	tst d4
	bne.s .pas_nul1
	moveq #0,d6
.pas_nul1:	swap d4
	add.w d6,d4			; nb de ligne  afficher
	clr d7
.pas_intersec:
	rts

;--------------------------------------------------------------------------------------

GWVA_WTEXT_OBJ_PRG_SCROLL_VERT:
	move GWVA_WIND_OBJ_REDRAW_CLIP,d0		; d0 = x1 source, destination
	move GWVA_WIND_OBJ_REDRAW_CLIP+4,d2		; d2 = x2 source, destination

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	muls GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d6

	tst d6
	bmi .scroll_bas

	move GWVA_WIND_OBJ_REDRAW_CLIP+2,d1
	add.w d6,d1			; d1 = y1 source

	move GWVA_WIND_OBJ_REDRAW_CLIP+6,d3		; d3 = y2 source
	
	move GWVA_WIND_OBJ_REDRAW_CLIP+2,d4		; d4 = y1 destination
	move.w d3,d5
	sub.w d6,d5			; d5 = y2 destination

	move.w d0,GWVA_WIND_OBJ_REDRAW_BLANK
	move.w d5,GWVA_WIND_OBJ_REDRAW_BLANK+2
	add.w #1,GWVA_WIND_OBJ_REDRAW_BLANK+2
	move.w d2,GWVA_WIND_OBJ_REDRAW_BLANK+4
	move.w d3,GWVA_WIND_OBJ_REDRAW_BLANK+6

.scroll_vert_com:
	cmp.w d1,d3
	ble.s .sup1ecran

	clr.l GWVA_WTEXT_OBJ_DUMMY

	save.l a0
	lea ptsin,a1
	move.w d0,(a1)+
	move.w d1,(a1)+
	move.w d2,(a1)+
	move.w d3,(a1)+
	move.w d0,(a1)+
	move.w d4,(a1)+
	move.w d2,(a1)+
	move.w d5,(a1)+
	vro_cpyfm #3,#GWVA_WTEXT_OBJ_DUMMY,#GWVA_WTEXT_OBJ_DUMMY	; scroll
	load.l a0

.sup1ecran:	movem.w GWVA_WIND_OBJ_REDRAW_BLANK,d0-d3
	sub.w d0,d2
	add.w #1,d2
	sub.w d1,d3
	add.w #1,d3
	lea GWVA_WIND_OBJ_REDRAW_INTERSEC,a2
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC
	tst d7
	bmi.s .no

	add.w d0,d2
	sub.w #1,d2
	add.w d1,d3
	sub.w #1,d3
	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_BLANK

	save.l d0/d1/a0
	save.l d0-d3
	vsf_color #0		; blanc
	vswr_mode #MD_REPLACE		; mode remplacement
	load.l d0-d3
	v_bar d0,d1,d2,d3		; barre blanche
	load.l d0/d1/a0
	clr d7
.no:	rts

.scroll_bas:
	move GWVA_WIND_OBJ_REDRAW_CLIP+2,d1		; d1 = y1 source

	move GWVA_WIND_OBJ_REDRAW_CLIP+6,d3
	add.w d6,d3			; d6<0  d3 = y2 source

	move GWVA_WIND_OBJ_REDRAW_CLIP+2,d4
	sub.w d6,d4			; d4 = y1 destination
	move GWVA_WIND_OBJ_REDRAW_CLIP+6,d5	; d5 = y2 destination

	move.w d4,d7
	sub.w #1,d7			; pour le blank
	movem.w d0/d1/d2/d7,GWVA_WIND_OBJ_REDRAW_BLANK
	bra .scroll_vert_com

	;--------------------------------------

GWVA_WTEXT_OBJ_PRG_SCROLL_HORI:
	move GWVA_WIND_OBJ_REDRAW_CLIP+2,d1		; d1 = y1 source, destination
	move GWVA_WIND_OBJ_REDRAW_CLIP+6,d3		; d3 = y2 source, destination

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	muls GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d6

	tst d6
	bmi .scroll_droite

	move GWVA_WIND_OBJ_REDRAW_CLIP,d0
	add.w d6,d0			; d0 = x1 source

	move GWVA_WIND_OBJ_REDRAW_CLIP+4,d2	; d2 = x2 source

	move GWVA_WIND_OBJ_REDRAW_CLIP,d4	; d4 = x1 destination
	move.w d2,d5
	sub.w d6,d5			; d5 = x2 destination

	move.w d5,GWVA_WIND_OBJ_REDRAW_BLANK
	add.w #1,GWVA_WIND_OBJ_REDRAW_BLANK
	move.w d1,GWVA_WIND_OBJ_REDRAW_BLANK+2
	move.w d2,GWVA_WIND_OBJ_REDRAW_BLANK+4
	move.w d3,GWVA_WIND_OBJ_REDRAW_BLANK+6

.scroll_hori_com:
	cmp.w d0,d2
	ble.s .sup1ecran

	clr.l GWVA_WTEXT_OBJ_DUMMY
	
	save.l a0
	lea ptsin,a1
	move.w d0,(a1)+
	move.w d1,(a1)+
	move.w d2,(a1)+
	move.w d3,(a1)+
	move.w d4,(a1)+
	move.w d1,(a1)+
	move.w d5,(a1)+
	move.w d3,(a1)+
	vro_cpyfm #3,#GWVA_WTEXT_OBJ_DUMMY,#GWVA_WTEXT_OBJ_DUMMY	; scroll
	load.l a0

.sup1ecran:	movem.w GWVA_WIND_OBJ_REDRAW_BLANK,d0-d3
	sub.w d0,d2
	add.w #1,d2
	sub.w d1,d3
	add.w #1,d3
	lea GWVA_WIND_OBJ_REDRAW_INTERSEC,a2
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC
	tst d7
	bmi.s .no

	add.w d0,d2
	sub.w #1,d2
	add.w d1,d3
	sub.w #1,d3
	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_BLANK

	save.l d0/d1/a0
	save.l d0-d3
	vsf_color #0		; blanc
	vswr_mode #MD_REPLACE		; mode remplacement
	load.l d0-d3
	v_bar d0,d1,d2,d3		; barre blanche
	load.l d0/d1/a0
	clr d7
.no:	rts
.scroll_droite:
	move GWVA_WIND_OBJ_REDRAW_CLIP,d0	; d0 = x1 source

	move GWVA_WIND_OBJ_REDRAW_CLIP+4,d2		; d2 = x2 source
	add.w d6,d2			; d6<0

	move GWVA_WIND_OBJ_REDRAW_CLIP,d4
	sub.w d6,d4			; d4 = x1 destination
	move GWVA_WIND_OBJ_REDRAW_CLIP+4,d5		; d5 = x2 destination

	move.w d0,GWVA_WIND_OBJ_REDRAW_BLANK
	move.w d1,GWVA_WIND_OBJ_REDRAW_BLANK+2
	move.w d4,GWVA_WIND_OBJ_REDRAW_BLANK+4
	sub.w #1,GWVA_WIND_OBJ_REDRAW_BLANK+4
	move.w d3,GWVA_WIND_OBJ_REDRAW_BLANK+6

	bra .scroll_hori_com

;-----------------------------------------------------------------------------
; GWVA_WTEXT_OBJ_PRG_CALCULATE_PHSLIDE2:	Calcul la position du curseur colonne courant d'affichage
;	Entres:	a0	: ptr sur struc. de la fentre
;	Sortie:	
;-----------------------------------------------------------------------------
GWVA_WTEXT_OBJ_PRG_CALCULATE_PHSLIDE2:
	move GWVA_WIND_OBJ_INTERNAL_W(a0),d2
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d2

*	cmp.w #GWVA_WIND_TYPE_TEXT,GWVA_WIND_OBJ_TYPE(a0)
*	bne.s .pas_texte

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	ext.l d2
	divu GWVA_WTEXT_OBJ_CELL_WIDTH(a1),d2	; nb colonnes  l'cran

	move GWVA_WTEXT_OBJ_NB_COLONNES(a1),d1
	sub.w d2,d1
	move.w d1,d3
	cmp.w GWVA_WTEXT_OBJ_AFF_COLONNE(a1),d1
	ble.s .min
	move.w GWVA_WTEXT_OBJ_AFF_COLONNE(a1),d1
.min:	tst d1
	bpl.s .max
	clr d1
.max:	move.w d1,GWVA_WTEXT_OBJ_AFF_COLONNE(a1)

*.pas_texte:
	rts


;-----------------------------------------------------------------------------
; GWVA_WTEXT_OBJ_PRG_CALCULATE_PVSLIDE2:	Calcul la position du curseur ligne d'affichage courant.
;	Entres:	a0	: ptr sur struc. de la fentre
;	Sortie:	
;-----------------------------------------------------------------------------
GWVA_WTEXT_OBJ_PRG_CALCULATE_PVSLIDE2:
	move GWVA_WIND_OBJ_INTERNAL_H(a0),d2	; hauteur interne de la fentre sans la toolbar
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d2

*	cmp.w #GWVA_WIND_TYPE_TEXT,GWVA_WIND_OBJ_TYPE(a0)	; fentre texte ?
*	bne.s .pas_texte

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	ext.l d2
	divu GWVA_WTEXT_OBJ_CELL_HEIGHT(a1),d2	; nb lignes pouvant tre affiches dans la fentre
					; de 1  n
	move GWVA_WTEXT_OBJ_BUF_LIGNE(a1),d1
	add.w #1,d1
	sub.w d2,d1				; d1 = numro de 1er ligne de la fentre
	move.w d1,d3
	cmp.w GWVA_WTEXT_OBJ_AFF_LIGNE(a1),d1	; on rectifie
	ble.s .min
	move.w GWVA_WTEXT_OBJ_AFF_LIGNE(a1),d1
.min:	tst d1
	bpl.s .max
	clr d1
.max:	move.w d1,GWVA_WTEXT_OBJ_AFF_LIGNE(a1)

*.pas_texte:
	rts
