****************************************************************************
* NE PAS UTILISER DEUX FOIS LE MEME OBJET POUR DEUX FENETRES DIFFERENTES.
* SINON PROBLEMES DE REDRAW AU MAUVAIS ENDROIT -> corrig en pl 37 : Multi-Form

GWVA_WIND_OBJ_PRG_WM_REDRAW:
	btst #GWVA_WIN_BIT_ICON,GWVA_WIND_OBJ_STATUS+1(a0)	; iconifie ?
	beq.s .window_not_inconified
	move.l GWVA_WIND_OBJ_ICON_WIND_PTR(a0),a0	; ptr sur la structure de la fenetre iconifie
.window_not_inconified:

	btst #GWVA_WIN_BIT_OPEN,GWVA_WIND_OBJ_STATUS+1(a0)	; fentre ouverte ?
	beq .no_redraw_window

	btst #GWVA_WIN_BIT_NAMIFIED,GWVA_WIND_OBJ_STATUS+1(a0)	; namified ?
	bne .no_redraw_cause_namified

	; par dfaut on raffiche tout
	move.w #0,GWVA_WIND_OBJ_FORM_NUM_OBJ_REDRAW
	move.w #7,GWVA_WIND_OBJ_FORM_DEPTH_OBJ_REDRAW
	move.w #-1,GWVA_WIND_OBJ_FORM_WHAT_OBJ_REDRAW	; all

	tst GWVA_APP_OBJ_MSG_BUF+2*2	; message tendu ? (+ de 16 octets)
	beq.s .redraw_all

	move.w GWVA_APP_OBJ_MSG_EXT_BUF,GWVA_WIND_OBJ_FORM_WHAT_OBJ_REDRAW
	move.w GWVA_APP_OBJ_MSG_EXT_BUF+2,GWVA_WIND_OBJ_FORM_NUM_OBJ_REDRAW
	move.w GWVA_APP_OBJ_MSG_EXT_BUF+4,GWVA_WIND_OBJ_FORM_DEPTH_OBJ_REDRAW
.redraw_all:

	bsr GWVA_WIND_OBJ_PRG_UPDATE_TOOLB_AND_FORM_POS

	ifd MDL_WIND_TEXT		; AFFICHAGE TEXT

	cmp.w #GWVA_WIND_TYPE_TEXT,GWVA_WIND_OBJ_TYPE(a0)
	bne .pas_text1

	save.l a0
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	vst_height GWVA_WTEXT_OBJ_FNT_SIZE(a1)
	vst_alignment #0,#5		; aligne en haut  gauche
	load.l a0
.pas_text1:
	endc

	save.l a0
	wind_update #BEG_UPDATE
	load.l a0

	movem.w GWVA_APP_OBJ_MSG_BUF+4*2,d0-d3
	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_BOX	; zone  redessiner
	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_FIRSTXYWH
	load.l a0

.draw_all_rectangles:
	tst.l int_out+6		; largeur & hauteur nulle ?
	beq .no_more_rectangle

	movem.w int_out+2,d0-d3		; position et taille du rectangle GEM de la fentre

; On dtermine en premier la zone qu'il faut effectivement redessiner

	lea GWVA_WIND_OBJ_REDRAW_BOX,a2	; intersection du rectangle de la fentre
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC	; avec la zone  redessiner
	tst d7
	bmi .pas_intersection		; pas d'intersection = pas de redraw necessaire dans cette zone
; -> d0-d3 = nouveau rectangle de redraw

	lea GWVA_APP_OBJ_DESKTOP_X,a2	; intersection du rectangle prcdent
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC	; avec le bureau
	tst d7
	bmi .pas_intersection		; pas d'intersection avec le bureau = la zone est en dehors de l'cran ...
; -> d0-d3 = rectangle effectif de redraw

	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_CLIP	; x,y,w,h de la zone  redessiner

; ---------- AFFICHAGE MENU ----------
	ifd MDL_WIND_MENU

	btst #GWVA_WIN_BIT_AMENU,GWVA_WIND_OBJ_PROPERTIES+1(a0)	; Menu ?
	beq .no_menu

	; redraw du menu
	save.l a0
	v_hide_c
	move.l (sp),a0
	objc_draw <(GWVA_MENU_STRUCT_PTR,[GWVA_WIND_OBJ_MENU_SPEC_PTR,a0])>,
&	#0,#4,GWVA_WIND_OBJ_REDRAW_CLIP,GWVA_WIND_OBJ_REDRAW_CLIP+2,GWVA_WIND_OBJ_REDRAW_CLIP+4,GWVA_WIND_OBJ_REDRAW_CLIP+6
	v_show_c #1
	load.l a0

	; redraw des fleches
	save.l a0
	v_hide_c
	objc_draw #GWVA_WIND_OBJ_MENU_TREE_ARROWS,
&	#0,#2,GWVA_WIND_OBJ_REDRAW_CLIP,GWVA_WIND_OBJ_REDRAW_CLIP+2,GWVA_WIND_OBJ_REDRAW_CLIP+4,GWVA_WIND_OBJ_REDRAW_CLIP+6
	v_show_c #1
	load.l a0
.no_menu:
	endc

	cmp #2,GWVA_WIND_OBJ_FORM_WHAT_OBJ_REDRAW
	beq .redraw_only_menu

; ---------- AFFICHAGE TOOLBAR ----------

	ifd MDL_WIND_TOOLBAR

	tst.l GWVA_WIND_OBJ_FIRST_SON_PTR(a0)	; toolbar ?
	beq .pas_de_toolbar

	btst #GWVA_WIN_BIT_HIDETREE,([GWVA_WIND_OBJ_FIRST_SON_PTR,a0],GWVA_WIND_OBJ_PROPERTIES+1)
	bne .pas_de_redraw_fenetres_filles

	; redraw de la toolbar
	save.l a0
	v_hide_c
	movem.l (sp),a0

	tst GWVA_WIND_OBJ_FORM_WHAT_OBJ_REDRAW
	bmi.s .redraw_all_objects_toolbar

	cmp #1,GWVA_WIND_OBJ_FORM_WHAT_OBJ_REDRAW
	bne .pas_de_redraw_toolbar_demande

	move.l ([GWVA_WIND_OBJ_FIRST_SON_PTR,a0],GWVA_WIND_OBJ_SPEC_PTR),a1
	objc_draw GWVA_WFORM_OBJ_FORM_PTR(a1),
&	GWVA_WIND_OBJ_FORM_NUM_OBJ_REDRAW,GWVA_WIND_OBJ_FORM_DEPTH_OBJ_REDRAW,GWVA_WIND_OBJ_REDRAW_CLIP,GWVA_WIND_OBJ_REDRAW_CLIP+2,GWVA_WIND_OBJ_REDRAW_CLIP+4,GWVA_WIND_OBJ_REDRAW_CLIP+6
	bra.s .redraw_toolbar_done

.redraw_all_objects_toolbar:
	move.l ([GWVA_WIND_OBJ_FIRST_SON_PTR,a0],GWVA_WIND_OBJ_SPEC_PTR),a1
	objc_draw GWVA_WFORM_OBJ_FORM_PTR(a1),
&	#0,#7,GWVA_WIND_OBJ_REDRAW_CLIP,GWVA_WIND_OBJ_REDRAW_CLIP+2,GWVA_WIND_OBJ_REDRAW_CLIP+4,GWVA_WIND_OBJ_REDRAW_CLIP+6
.redraw_toolbar_done:

.pas_de_redraw_toolbar_demande:
	v_show_c #1
	load.l a0

.pas_de_redraw_fenetres_filles:
.pas_de_toolbar:
	endc

	cmp #1,GWVA_WIND_OBJ_FORM_WHAT_OBJ_REDRAW
	beq .redraw_only_toolbar

; -------------- ----------------- ---------------- --------------- --------------
; -------------- ----------------- ---------------- --------------- --------------

; Aprs le redessin du menu et de la Toolbar, on change les coordonne pour traiter le
; contenu de la fentre

	move.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d4
	add.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d4
	move.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d5
	add.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d5	; d4-d5 : position du contenu

	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3

	cmp.w d4,d0
	bge.s .redraw_au_dela_zone_x
	move d0,d6
	sub d4,d6
	add d6,d2		; raccourci la taille de la zone de redraw
	move d4,d0		; on commence le redraw dans le contents
.redraw_au_dela_zone_x:

	cmp.w d5,d1
	bge.s .redraw_au_dela_zone_y
	move d1,d6
	sub d5,d6
	add d6,d3		; raccourci la taille de la zone de redraw
	move d5,d1		; on commence le redraw dans le contents
.redraw_au_dela_zone_y:

; On doit de nouveau vrifier si le nouveau rectangle de redraw est valide
; Le rectangle peut avoir chang de taille et de position

	lea GWVA_WIND_OBJ_REDRAW_BOX,a2	; intersection du rectangle de la fentre
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC	; avec la zone  redessiner
	tst d7
	bmi .pas_intersection		; pas d'intersection = pas de redraw necessaire dans cette zone
; -> d0-d3 = nouveau rectangle de redraw

	lea GWVA_APP_OBJ_DESKTOP_X,a2	; intersection du rectangle prcdent
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC	; avec le bureau
	tst d7
	bmi .pas_intersection		; pas d'intersection avec le bureau = la zone est en dehors de l'cran ...
; -> d0-d3 = rectangle effectif de redraw

	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_CLIP	; x,y,w,h de la zone  redessiner

; ---------- AFFICHAGE TEXT ----------

	ifd MDL_WIND_TEXT		; AFFICHAGE TEXT

	cmp.w #GWVA_WIND_TYPE_TEXT,GWVA_WIND_OBJ_TYPE(a0)
	bne .pas_text2

	save.l a0

	add.w d0,d2
	subq #1,d2
	add.w d1,d3
	subq #1,d3
	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_CLIP
	vs_clip #1,d0,d1,d2,d3		; clip on : x1,y1 -> x2,y2

	; aucun intret de mettre une user routine WM_BEFORE ici
	; car de toute faon on fait un rectangle blanc

	v_hide_c
	vswr_mode #MD_REPLACE
	vsf_color #0		; blanc
	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3
	v_bar d0,d1,d2,d3
	v_show_c #1
	load.l a0

	lea GWVA_WIND_OBJ_REDRAW_CLIP,a6
	bsr GWVA_WTEXT_OBJ_PRG_CALC_PARAM_TEXT
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WTEXT_OBJ_CUR_BUF_LIGN(a1),d6

	cmp.w d6,d2
	bgt.s .pas_reaffich

	save.l d0-d6/a0
	v_hide_c
	load.l d0-d6/a0

	bsr GWVA_WTEXT_OBJ_PRG_WRITE_TEXT_IN_WINDOW

	save.l a0
	v_show_c #1
	load.l a0

.pas_reaffich:
	save.l a0
	vs_clip #0,#0,#0,#0,#0
	load.l a0

.pas_text2:
	endc

; ---------- AFFICHAGE FORM ----------

	ifd MDL_WIND_FORM

	cmp.w #GWVA_WIND_TYPE_FORM,GWVA_WIND_OBJ_TYPE(a0)
	bne .pas_form2

	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3

	save.l a0

	v_hide_c
	move.l (sp),a0

	tst.w GWVA_WIND_OBJ_FORM_WHAT_OBJ_REDRAW
	bge.s .redraw_not_all_object

	clr.w d0
	move.w #7,d1
	bsr .usr_bef_redraw_usr_aft
	bra .fin_redraw_formulaire

.redraw_not_all_object:
	lea GWVA_APP_OBJ_MSG_EXT_BUF+2,a2
.boucle_parse_all_objects:
	cmp.w #-1,(a2)
	beq .fin_boucle_parse_all_objects
	save.l a0/a2
	movem.w (a2),d0/d1
	bsr .usr_bef_redraw_usr_aft
	load.l a0/a2
	lea 2*2(a2),a2
	bra.s .boucle_parse_all_objects

.usr_bef_redraw_usr_aft:
	move.w d0,GWVA_WIND_OBJ_FORM_NUM_OBJ_REDRAW
	move.w d1,GWVA_WIND_OBJ_FORM_DEPTH_OBJ_REDRAW

	save.l a0

	bsr GWVA_WFORM_PRG_CALC_POS_SIZE_OBJ

	lea GWVA_WIND_OBJ_REDRAW_CLIP,a2
	bsr GWVA_WIND_OBJ_PRG_INTERSEC_REC
	tst d7
	bmi .pas_intersection_objet_rectangle_reduit

	add.w d0,d2
	add.w d1,d3
	sub.w #1,d2
	sub.w #1,d3
	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_INTERSECT_OBJECT

	; user routine

	move #WM_BEFORE+WM_REDRAW,d4
	bsr GWVA_TEST_IF_USER_REDRAW_ROUTINE_EXISTS
	tst d7
	bmi .pas_user_redraw_before

	movem.w GWVA_WIND_OBJ_REDRAW_INTERSECT_OBJECT,d0-d3
	vs_clip #1,d0,d1,d2,d3

	move.l (sp),a0
	movem.w GWVA_WIND_OBJ_REDRAW_INTERSECT_OBJECT,d0-d3
	move #WM_BEFORE+WM_REDRAW,d4
	bsr GWVA_JUMP_TO_USER_REDRAW_ROUTINE

	save.w d7
	vs_clip #0,#0,#0,#0,#0
	load.w d7

	tst d7
	bmi .user_cancelled_redraw

.pas_user_redraw_before:
	move.l (sp),a0
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1

	movem.w GWVA_WIND_OBJ_REDRAW_INTERSECT_OBJECT,d0-d3
	sub.w d0,d2
	sub.w d1,d3
	add.w #1,d2
	add.w #1,d3
	objc_draw GWVA_WFORM_OBJ_FORM_PTR(a1),GWVA_WIND_OBJ_FORM_NUM_OBJ_REDRAW,GWVA_WIND_OBJ_FORM_DEPTH_OBJ_REDRAW,d0,d1,d2,d3

.user_cancelled_redraw:
	; user routine

	move.l (sp),a0
	move #WM_AFTER+WM_REDRAW,d4
	bsr GWVA_TEST_IF_USER_REDRAW_ROUTINE_EXISTS
	tst d7
	bmi .pas_user_redraw_after

	movem.w GWVA_WIND_OBJ_REDRAW_INTERSECT_OBJECT,d0-d3
	vs_clip #1,d0,d1,d2,d3

	move.l (sp),a0
	movem.w GWVA_WIND_OBJ_REDRAW_INTERSECT_OBJECT,d0-d3
	move #WM_AFTER+WM_REDRAW,d4
	bsr GWVA_JUMP_TO_USER_REDRAW_ROUTINE

	vs_clip #0,#0,#0,#0,#0

.pas_user_redraw_after:

; ------------------ AFFICHAGE DU CURSEUR TEXTE ---------------------

	ifd PATCH_WIND_FORM_CUSTOM_EDITABLE_TEXT

	movem.w GWVA_WIND_OBJ_REDRAW_INTERSECT_OBJECT,d0-d3
	vs_clip #1,d0,d1,d2,d3

	move.l (sp),a0
	bsr GWVA_WIND_OBJ_PRG_REDRAW_ED_TXT_CURSOR

	vs_clip #0,#0,#0,#0,#0

	endc
;-----------

.pas_intersection_objet_rectangle_reduit:

	load.l a0
	rts

.fin_boucle_parse_all_objects:
.fin_redraw_formulaire:

	v_show_c #1
	load.l a0
.pas_form2:
	endc

; ---------- AFFICHAGE CUSTOM ----------

	ifd MDL_WIND_CUSTOM

	cmp.w #GWVA_WIND_TYPE_CUSTOM,GWVA_WIND_OBJ_TYPE(a0)
	bne .pas_custom1

	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3

	save.l a0
	add.w d0,d2
	subq #1,d2
	add.w d1,d3
	subq #1,d3
	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_CLIP	; x1,y1,x2,y2
	vs_clip #1,d0,d1,d2,d3
	v_hide_c

	move.l (sp),a0

	; user routine

	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3
	move #WM_BEFORE+WM_REDRAW,d4		; ds fois que
	bsr GWVA_JUMP_TO_USER_REDRAW_ROUTINE

	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3
	move #WM_AFTER+WM_REDRAW,d4		; ...
	bsr GWVA_JUMP_TO_USER_REDRAW_ROUTINE

	v_show_c #1
	vs_clip #0,#0,#0,#0,#0

	load.l a0
.pas_custom1:

	endc

; ---------- AFFICHAGE BITMAP ----------

	ifd MDL_WIND_BITMAP		; AFFICHAGE BITMAP

	cmp.w #GWVA_WIND_TYPE_BITMAP,GWVA_WIND_OBJ_TYPE(a0)
	bne .pas_bitmap

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1

	move GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2,d4
	cmp.w GWVA_WBITM_OBJ_NBR_BITPLANES(a1),d4
	bne .pas_le_meme_nb_plan

	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3

	save.l a0

	add.w d0,d2
	add.w d1,d3
	subq #1,d2
	subq #1,d3
	movem.w d0-d3,GWVA_WIND_OBJ_REDRAW_CLIP	; x1,y1,x2,y2
	vs_clip #1,d0,d1,d2,d3

	ifd OPT_GWVA_WIND_REDRAW_HIDE_MOUSE
	bsr GWVA_WIND_OBJ_PRG_REDRAW_BEST_HIDE_MOUSE
	else
	v_hide_c
	endc

	move.l (sp),a0

	; user routine

	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3
	move #WM_BEFORE+WM_REDRAW,d4
	bsr GWVA_JUMP_TO_USER_REDRAW_ROUTINE
	tst d7
	bmi .zap_redraw

	move.l (sp),a0
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1

	lea GWVA_APP_MFDB_SRC,a2
	move.l GWVA_WBITM_OBJ_DATA_PTR(a1),(a2)+	; pointeur image
	move.l GWVA_WBITM_OBJ_IMG_WIDTH(a1),(a2)+	; largeur image pixel

	move.w GWVA_WBITM_OBJ_IMG_WIDTH(a1),d5
	add.w #15,d5
	ext.l d5
	divu #16,d5
	move.w d5,(a2)+			; largeur image en mots

	move.w #0,(a2)+			; device dependent

	move.w GWVA_WBITM_OBJ_NBR_BITPLANES(a1),(a2)+
	clr.w (a2)+				; reservs
	clr.w (a2)+
	clr.w (a2)+

	clr.l GWVA_APP_MFDB_DEST

	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3
	sub.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d0
	sub.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d2
	sub.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d1
	sub.w GWVA_WIND_OBJ_INTERNAL_DY(a0),d3
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	sub.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d2
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1
	sub.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d3
	add.w GWVA_WBITM_OBJ_AFF_DX(a1),d0
	add.w GWVA_WBITM_OBJ_AFF_DX(a1),d2
	add.w GWVA_WBITM_OBJ_AFF_DY(a1),d1
	add.w GWVA_WBITM_OBJ_AFF_DY(a1),d3
	movem.w d0-d3,ptsin

	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3
	movem.w d0-d3,ptsin+8

	vro_cpyfm #3,#GWVA_APP_MFDB_SRC,#GWVA_APP_MFDB_DEST	; REPLACE mode
	
.zap_redraw:
	move.l (sp),a0

	; user routine
	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3
	move #WM_AFTER+WM_REDRAW,d4
	bsr GWVA_JUMP_TO_USER_REDRAW_ROUTINE

	ifd OPT_GWVA_WIND_REDRAW_HIDE_MOUSE
	tst.w GWVA_WIND_OBJ_REDRAW_MOUSE_STATE
	beq.s .pas_rafficher_mouse
	endc

	v_show_c #1

	ifd OPT_GWVA_WIND_REDRAW_HIDE_MOUSE
	clr.w GWVA_WIND_OBJ_REDRAW_MOUSE_STATE
.pas_rafficher_mouse:
	endc

	vs_clip #0,#0,#0,#0,#0

	load.l a0

.pas_le_meme_nb_plan:
.pas_bitmap:
	endc


.redraw_only_toolbar:
.redraw_only_menu:
.pas_intersection
	save.l a0
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_NEXTXYWH
	load.l a0
	bra .draw_all_rectangles

.no_more_rectangle:

; --------------------------- FIN DU REDRAW ---------------------------------

	ifnd PATCH_WIND_FORM_CUSTOM_EDITABLE_TEXT

	ifd MDL_WIND_FORM		; END REDRAW FORM

	cmp.w #GWVA_WIND_TYPE_FORM,GWVA_WIND_OBJ_TYPE(a0)
	bne .pas_form3

	save.l a0
	bsr GWVA_WIND_OBJ_PRG_RETURN_TOP_WINDOW
	load.l a0
	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0
	bne .no_top

	btst #GWVA_WIN_BIT_CURS,GWVA_WIND_OBJ_STATUS+1(a0)
	bne.s .curseur_deja_affiche

	save.l a0
	v_hide_c
	move.l (sp),a0

	bsr GWVA_WIND_OBJ_PRG_REDRAW_ED_TXT_CURSOR

	v_show_c #1
	load.l a0

	bset #GWVA_WIN_BIT_CURS,GWVA_WIND_OBJ_STATUS+1(a0)

.curseur_deja_affiche:
.no_top:
.pas_form3:
	endc	; ifd MDL_WIND_FORM

	endc	; ifnd PATCH_WIND_FORM_CUSTOM_EDITABLE_TEXT

	save.l a0
	wind_update #END_UPDATE
	load.l a0

.no_redraw_cause_namified:
.no_redraw_window:

	rts

		*--------------------------*

GWVA_WFORM_PRG_CALC_POS_SIZE_OBJ:		; a0 = ptr fenetre, d0 = objet, -> d0-d3
; Calcul de la position et de la taille "vraie" d'un objet (avec les sculptures)
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	save.l d0/a0/a1
	objc_offset GWVA_WFORM_OBJ_FORM_PTR(a1),d0
	load.l d0/a0/a1
	tst.w d0
	bne.s .pas_objet_pere		; On doit prendre en compte les sculptures de l'objet

	movem.w GWVA_WIND_OBJ_INTERNAL_DX(a0),d0-d3
	movem.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d4-d5
	add.w d4,d0
	add.w d5,d1
	sub.w d4,d2
	sub.w d5,d3
	bra.s .com_form
.pas_objet_pere:
	move.l GWVA_WFORM_OBJ_FORM_PTR(a1),a2
	mulu #L_OBJECT,d0
	add.l d0,a2
	movem.w int_out+1*2,d0-d1
	movem.w ob_width(a2),d2-d3

; Recherche du dcalage 3D
	cmp.w #$340,global+_AESversion
	blt.s .pas_AES340

	move.w ob_flags(a2),d4
	btst #9,d4
	beq.s .pas_objet_indicateur_activateur

	save.w d0-d3

; On demande le nombre de pixel pour la 3D
	objc_sysvar #0,#6,#0,#0
	load.w d0-d3
	move.w int_out+1*2,d4
	move.w int_out+2*2,d5
	sub.w d4,d0		; dcalage du curseur en X (3D)
	add.w d4,d2
	add.w d4,d2		; ajoute deux fois 2 pixels a gauche et a droite
	sub.w d5,d1		; dcalage du curseur en Y (3D)
	add.w d5,d3
	add.w d5,d3		; ajoute deux fois 2 pixels en haut et en bas

.pas_objet_indicateur_activateur:
.pas_AES340:

.com_form:
	rts
		*--------------------------*

GWVA_WIND_OBJ_PRG_REDRAW_ED_TXT_CURSOR:	; a0 = pointeur sur une structure fenetre

	tst GWVA_WIND_OBJ_FOCUSED_OBJECT(a0)
	bmi .no_editable_text

	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.w GWVA_WFORM_OBJ_FORM_IDX(a1),d0
	move.w GWVA_WIND_OBJ_FOCUSED_OBJECT(a0),d1

	save.l a0-a1
	bsr RETURN_TEXT_OBJ_IN_FORM_OBJ_PTR
	move.l a1,a2		; a2.l = adresse du texte ditable
	movem.l (sp),a0-a1

	add.w GWVA_WIND_OBJ_FOCUSED_OBJ_CURSOR_POS(a0),a2
	; a2 pointe sur la position du curseur dans le champs texte
	move.b (a2),d0
	clr.b (a2)		; pour forcer le GEM  mettre le curseur autre part qu'en fin de chaine

	save.l d0/a2

	ifnd PATCH_WIND_FORM_CUSTOM_EDITABLE_TEXT
	objc_edit GWVA_WFORM_OBJ_FORM_PTR(a1),GWVA_WIND_OBJ_FOCUSED_OBJECT(a0),#0,GWVA_WIND_OBJ_FOCUSED_OBJ_CURSOR_POS(a0),#1
	else
	move.w GWVA_WIND_OBJ_FOCUSED_OBJECT(a0),d0
	move.w #0,d1
	move.w GWVA_WIND_OBJ_FOCUSED_OBJ_CURSOR_POS(a0),d2
	move.w #1,d3
	move.l GWVA_WFORM_OBJ_FORM_PTR(a1),a0
	bsr GWVA_WFORM_OBJ_PRG_OBJC_EDIT
	endc

	load.l d0/a2

	move.b d0,(a2)	; on restaure le caractre
	movem.l (sp),a0-a1
	move.w int_out+2,GWVA_WIND_OBJ_FOCUSED_OBJ_CURSOR_POS(a0)	; nouvelle position du curseur

	load.l a0-a1

.no_editable_text:

	rts

		*--------------------------*
GWVA_TEST_IF_USER_REDRAW_ROUTINE_EXISTS:	; a0=ptr fenetre, d4=numro message (d0-d3 non modifis)
	move.w #GWVA_ERROR_GENERIC,d7

	lea GWVA_WIND_OBJ_START_EVNT_LIST(a0),a2
.search:	tst.w (a2)
	bmi.s .not_found
	cmp.w (a2),d4
	beq.s .found
	lea 2+4(a2),a2
	bra.s .search

.found:	clr.w d7
.not_found:	rts

		*--------------------------*
GWVA_JUMP_TO_USER_REDRAW_ROUTINE:	; a0=ptr fenetre, d0-d3=zone de clipping, d4=numro message
	clr d7

	lea GWVA_WIND_OBJ_START_EVNT_LIST(a0),a2
.search:	tst.w (a2)
	bmi.s .not_found
	cmp.w (a2),d4
	beq.s .found
	lea 2+4(a2),a2
	bra.s .search

.found:			; zone de clipping x1,y1,x2,y2 dans d0-d3
			; a0 = ptr fenetre
			; a1 = ptr spec fenetre
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	jsr ([a2,2])	; retour d7 important si WM_BEFORE

.not_found:	rts
		*--------------------------*
	ifd OPT_GWVA_WIND_REDRAW_HIDE_MOUSE

GWVA_WIND_OBJ_PRG_REDRAW_BEST_HIDE_MOUSE:
	clr.w GWVA_WIND_OBJ_REDRAW_MOUSE_STATE
	graf_mkstate
	movem.w GWVA_WIND_OBJ_REDRAW_CLIP,d0-d3
	add.w #16,d2
	add.w #16,d3
	sub.w #16,d0
	sub.w #16,d1
	movem.w int_out+1*2,d4-d5		; x,y de la souris
	cmp.w d4,d0
	bgt.s .no_hide_mouse
	cmp.w d4,d2
	blt.s .no_hide_mouse
	cmp.w d5,d1
	bgt.s .no_hide_mouse
	cmp.w d5,d3
	blt.s .no_hide_mouse
	v_hide_c
	move.w #1,GWVA_WIND_OBJ_REDRAW_MOUSE_STATE
.no_hide_mouse:
	rts
	endc
